aboutsummaryrefslogtreecommitdiffstats
path: root/target/linux/omap
diff options
context:
space:
mode:
authorLucian Cristian <lucian.cristian@gmail.com>2018-07-19 09:55:19 +0300
committerJohn Crispin <john@phrozen.org>2018-07-30 11:03:02 +0200
commit6a095e858718e91a56dc69f21b5ecb76237e7c28 (patch)
tree5c75d65cfcb907be71107ff2aada4dc84e1df7fe /target/linux/omap
parent40f66f1431b1a6638f05b75952d7b5a94e385e8d (diff)
downloadupstream-6a095e858718e91a56dc69f21b5ecb76237e7c28.tar.gz
upstream-6a095e858718e91a56dc69f21b5ecb76237e7c28.tar.bz2
upstream-6a095e858718e91a56dc69f21b5ecb76237e7c28.zip
omap: add sysupgrade support
add sysupgrade missing script files Signed-off-by: Lucian Cristian <lucian.cristian@gmail.com>
Diffstat (limited to 'target/linux/omap')
-rw-r--r--target/linux/omap/base-files/lib/preinit/79_move_config20
-rw-r--r--target/linux/omap/base-files/lib/upgrade/platform.sh89
2 files changed, 109 insertions, 0 deletions
diff --git a/target/linux/omap/base-files/lib/preinit/79_move_config b/target/linux/omap/base-files/lib/preinit/79_move_config
new file mode 100644
index 0000000000..c112588689
--- /dev/null
+++ b/target/linux/omap/base-files/lib/preinit/79_move_config
@@ -0,0 +1,20 @@
+#!/bin/sh
+# Copyright (C) 2012-2015 OpenWrt.org
+
+move_config() {
+ local partdev
+
+ . /lib/upgrade/common.sh
+
+ if export_bootdevice && export_partdevice partdev -1; then
+ if mount -t vfat -o rw,noatime "/dev/$partdev" /mnt; then
+ if [ -f /mnt/sysupgrade.tgz ]; then
+ mv -f /mnt/sysupgrade.tgz /
+ fi
+ umount /mnt
+ fi
+ fi
+}
+
+boot_hook_add preinit_mount_root move_config
+
diff --git a/target/linux/omap/base-files/lib/upgrade/platform.sh b/target/linux/omap/base-files/lib/upgrade/platform.sh
new file mode 100644
index 0000000000..88ef4790e9
--- /dev/null
+++ b/target/linux/omap/base-files/lib/upgrade/platform.sh
@@ -0,0 +1,89 @@
+platform_check_image() {
+ local diskdev partdev diff
+
+ export_bootdevice && export_partdevice diskdev -2 || {
+ echo "Unable to determine upgrade device"
+ return 1
+ }
+
+ get_partitions "/dev/$diskdev" bootdisk
+
+ #extract the boot sector from the image
+ get_image "$@" | dd of=/tmp/image.bs count=1 bs=512b 2>/dev/null
+
+ get_partitions /tmp/image.bs image
+
+ #compare tables
+ diff="$(grep -F -x -v -f /tmp/partmap.bootdisk /tmp/partmap.image)"
+
+ rm -f /tmp/image.bs /tmp/partmap.bootdisk /tmp/partmap.image
+
+ if [ -n "$diff" ]; then
+ echo "Partition layout has changed. Full image will be written."
+ ask_bool 0 "Abort" && exit 1
+ return 0
+ fi
+}
+
+platform_copy_config() {
+ local partdev
+
+ if export_partdevice partdev -1; then
+ mount -t vfat -o rw,noatime "/dev/$partdev" /mnt
+ cp -af "$CONF_TAR" /mnt/
+ umount /mnt
+ fi
+}
+
+platform_do_upgrade() {
+ local diskdev partdev diff
+
+ export_bootdevice && export_partdevice diskdev -2 || {
+ echo "Unable to determine upgrade device"
+ return 1
+ }
+
+ sync
+
+ if [ "$SAVE_PARTITIONS" = "1" ]; then
+ get_partitions "/dev/$diskdev" bootdisk
+
+ #extract the boot sector from the image
+ get_image "$@" | dd of=/tmp/image.bs count=1 bs=512b
+
+ get_partitions /tmp/image.bs image
+
+ #compare tables
+ diff="$(grep -F -x -v -f /tmp/partmap.bootdisk /tmp/partmap.image)"
+ else
+ diff=1
+ fi
+
+ if [ -n "$diff" ]; then
+ get_image "$@" | dd of="/dev/$diskdev" bs=4096 conv=fsync
+
+ # Separate removal and addtion is necessary; otherwise, partition 1
+ # will be missing if it overlaps with the old partition 2
+ partx -d - "/dev/$diskdev"
+ partx -a - "/dev/$diskdev"
+
+ return 0
+ fi
+
+ #write uboot image
+ get_image "$@" | dd of="$diskdev" bs=1024 skip=8 seek=8 count=1016 conv=fsync
+ #iterate over each partition from the image and write it to the boot disk
+ while read part start size; do
+ part="$(($part - 2))"
+ if export_partdevice partdev $part; then
+ echo "Writing image to /dev/$partdev..."
+ get_image "$@" | dd of="/dev/$partdev" ibs="512" obs=1M skip="$start" count="$size" conv=fsync
+ else
+ echo "Unable to find partition $part device, skipped."
+ fi
+ done < /tmp/partmap.image
+
+ #copy partition uuid
+ echo "Writing new UUID to /dev/$diskdev..."
+ get_image "$@" | dd of="/dev/$diskdev" bs=1 skip=440 count=4 seek=440 conv=fsync
+}